您的位置:首页 > 其它

LeetCode-001 Two Sum

2017-09-10 20:56 393 查看

Description

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example

Given nums = [2, 7, 11, 15], target = 9, Because nums[0] + nums[1] = 2 + 7 = 9,

return [0, 1].

Analyse

其实这道题看起来很简单,就是在一个集合里面找到两个和为目标值的下标,只要学过一些基础的人都很容易想到时间复杂度为O(n2)的算法,就是两个循环遍历整个集合即可。这道题到这里就结束了,这就是这道题被评为Easy的原因。其实还有更快的,我们可以想到,若将集合先排好序,然后再去查找,时间复杂度将会降到O(nlogn)。要是再快点的话,直接做哈希,将每个元素做哈希,然后遍历整个集合,将目标值减去遍历值的差做哈希,哈希到的就是答案(因为题目保证了答案的唯一性),时间复杂度为

O(n),但空间复杂度也随之变大。

Code

这里只列出最简单的方法吧

class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
vector<int> ans;
for (int i=0;i<nums.size()-1;i++) {
for (int j=i+1;j<nums.size();j++) {
if (nums[i]+nums[j]==target) {
ans.push_back(i);
ans.push_back(j);
return ans;
}
}
}
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: